\chapter{Rings}
\begin{nonumconvention}
In this lecture rings are assumed to be
\begin{enumerate}
  \item commutative: for all $ab = ba$ holds for all $a,b\in R$,
  \item unital: there is an element $1=1_R\in R$ such that $1a=a$ for all $a\in R$.
\end{enumerate}
 Ring homomorphisms $f:R\to S$ always respect the unit, i.e. $f(1_R) = 1_S$ holds.
\end{nonumconvention}
\section{Ideals}
\begin{mdefn}
  Let $I\sse R$ be an ideal. Then $I$ is a \emph{proper ideal} \index{ideal!proper} or \emph{proper} if $I\neq R$.
\end{mdefn}
\begin{defn} \leavevmode
  \begin{enumerate}
    \item A proper ideal $\idp \ssne R$ is a \emph{prime ideal}\index{ideal! prime} if for all $x,y\in R$ with $xy \in \idp$, already $x\in \idp$ or $y\in \idp$ holds.
    \item A proper ideal $\idm \ssne R$ is a \emph{maximal ideal}\index{ideal! maximal} if there is no ideal $I$ with $\idm\ssne I \ssne R$.
  \end{enumerate}
\end{defn}
\begin{mnotation}
  I try to follow Dr. Heidersdorf's  way of naming ideals, with one typographical addition: ordinary ideals are denoted as $I,J$,..., prime ideals as $\idp$,... and maximal ideals as $\idm$,... .
\end{mnotation}

\begin{lem}\label{lec1:primmax-alt-char}
  Let $I\sse R$ be an ideal.
  \begin{enumerate}
    \item The following are equivalent:
    \begin{enumerate}[label = \alph*)]
      \item $I$ is a prime ideal.
      \item $R/I$ is an integral domain.
    \end{enumerate}
  \item The following are equivalent:
  \begin{enumerate}[label = \alph*)]
    \item $I$ is a maximal ideal.
    \item $R/I$ is a field.
  \end{enumerate}
  \end{enumerate}
\end{lem}
\begin{proof}
We denote the coset of an element $a\in R$ in $R/I$ by $\overline{a}$.
  \begin{enumerate}
    \item Let $I$ be a prime ideal, and let $\overline{x},\overline{y}\in R/I$ such that $0 = \overline{x}\cdot \overline{y} = \overline{xy}$. This means that $xy$ is in $I$. As $I$ is prime, $x\in I$ or $y\in I$ follows, and hence $\overline{x}=0$ or $\overline{y}=0$. \par
    Now assume that $R/I$ is an integral domain. Let $x,y\in R$ with $xy\in I$. Hence $0 = \overline{xy} = \overline{x}\cdot \overline{y}$, and as $R/I$ is an integral domain, $\overline{x} = 0$ or $\overline{y} = 0$ follows. So $x\in I$ or $y\in I$.
    \item Let $I$ be maximal, and $x\notin I$. Consider the ideal generated by $x$ and $I$, $\genby{I,x}$. As $I$ is maximal and $I\sse \genby{I,x}$, we have $\genby{I,x} = R = \genby{1}$. So there  are $z\in I$, $y\in R$ such that $1 = xy + z$. So in $R/I$, we have
    \[
    1 = \overline{xy+z} = \overline{x}\cdot \overline{y} + \overline{z} = \overline{x}\cdot \overline{y},
    \]
    which shows that $\overline{x}$ is a unit in $R/I$.\par
    Now assume that $R/I$ is a field and let $J$ be an ideal with $I\sse J \sse R$. If there is an $x\in J$ such that $x\notin I$, then $\overline{x}$ is invertible in $R/I$. So there are $z\in I$, $y\in R$ such that $1 = xy+z$. As $z\in J$ and $x\in J$ this implies $1\in J$, and hence $J=R$.
  \end{enumerate}
\end{proof}
\begin{cor}
  Let $I$ be an ideal. If $I$ is maximal then $I$ is prime.
\end{cor}
The following is a consequence of Zorn's Lemma and the ideal correspondence:
\begin{lem}\label{1: maximal existence}
  Let $R\neq 0$ be a ring.
  \begin{enumerate}
    \item $R$ contains a maximal ideal.
    \item Every ideal of $R$ is contained in some maximal ideal.
  \end{enumerate}
\end{lem}

\begin{cor}\label{1: existence of maximals}
  \leavevmode
  \begin{enumerate}
    \item Every $x\notin R\unts$ is contained in some maximal ideal of $R$.
    \item The units of $R$ are given by the complement of the union over all maximal ideals $\idm$:
    \[
    R\unts = R \setminus \bigcup_{\idm~\text{maximal ideal}} \idm.
    \]
    \item Let $R$ be a ring that has only one maximal ideal $\idm$ and let $x\in \idm$. Then $1+x$ is a unit. \label{1: existence of maximals: 1 plus maximal}
  \end{enumerate}
\end{cor}
\begin{proof}
  \leavevmode
  \begin{enumerate}
    \item Consider the ideal generated by $x$. As $x$ is not a unit $\genby{x} \ssne \genby{1}$ holds. So by \cref{1: existence of maximals}, there is a maximal ideal containing $\genby{x}$, and in particular $x$.
    \item Let $x\notin \idm$ for all maximal ideals $\idm$. Then $\genby{x}\ssne \idm$ for all maximal ideals $\idm$, and hence $\genby{x} = \genby{1}$.
    \item By ii), we have $R\unts = R\setminus \idm$, and since $1+x\in \idm$ would imply $\idm = R$, the claim follows.
  \end{enumerate}
\end{proof}
\begin{example}
  Consider the case $R = \zz$. Then the prime ideals are $\genby{0}$ and $\genby{p}$, for every prime number $p$.
\end{example}
\begin{mrem}\label{1: quotient of polynomial ring}
  Consider the polynomial ring $R[\polvariable_1,\hdots,\polvariable_n]$ in $n$ variables over a general ring $R$. Then for every $0\leq m\leq n$ there is a canonical isomorphism
  \[
  R[\polvariable_1,\hdots,\polvariable_n] / \genby{\polvariable_1,\hdots,\polvariable_m} \cong R[\polvariable_{m+1},\hdots,\polvariable_n].
  \]
\end{mrem}
\begin{example}
 Consider the polynomial ring in $n$ variables over an integral domain $R$. Then $\genby{\polvariable_1,\hdots,\polvariable_m}$ is prime for all $m\leq n$, since $R[\polvariable_{n+1},\hdots,\polvariable_m]$ is too. However it is not necessarily maximal:\par
  In the case $m=n=2$ the quotient $R[\polvariable_1,\polvariable_2]/\genby{\polvariable_1,\polvariable_2}$ is isomorphic to $R$. So by \cref{lec1:primmax-alt-char}, $\genby{\polvariable_1,\polvariable_2}$ is maximal if and only if $R$ is a field.
\end{example}
\subsection*{More on Ideals and Rings}
Most of the content of this subsection was not explicitly covered in the lecture, although we need some of it later on and for some exercises. Most of it comes from \cite{atiyah}.
\begin{prop}
  The category $\cring$ of commutative rings has all products: For each index set $\Lambda$ and a family of rings $\left(R_{\lambda}\right)_{\lambda\in \Lambda}$ there exists a ring $P$ and ring homomorphisms $p_{\lambda}:P\to R_{\lambda}$ such that for rings $Q$ and collections of ring homomorphisms $q_{\lambda}: Q\to R_{\lambda}$ there is a unique ring homomorphism $r:Q\to P$ such that the diagram
  \[
  \begin{tikzcd}
    &
    &
    R_{\lambda}\\
    Q\ar[bend left = 30]{urr}[above left]{q_{\lambda}}\ar[bend right = 30]{drr}[below left]{q_{\lambda'}}\ar[dashed]{r}[above]{r}&
    P\ar{ur}[below right]{p_{\lambda}}\ar{dr}[above right]{p_{\lambda'}}&
    \\
    &
    &
    R_{\lambda'}
  \end{tikzcd}
  \]
  commutes for all $\lambda,\lambda'\in \Lambda$.
\end{prop}
\begin{proof}
  We choose as $P$ the set-theoretic product $\prod_{\lambda \in \Lambda}R_{\lambda}$ and endow it with component-wise addition and projection.
\end{proof}
In the following, the product of a family of rings will always be denoted by the usual product symbol $\prod$.
\begin{remdef}\label{lec1:ideal-basic-ops}
  \leavevmode
  \begin{enumerate}
    \item Let $\left(I_{\lambda}\right)_{\lambda\in \Lambda}$ be a family of ideals. Then the intersection
    \[
    \bigcap_{\lambda \in \Lambda}I_{\lambda}
    \]
    is an ideal too. For a general subset $M$, we define
    \[
    \genby{M} \defined \bigcap_{\substack{I\sse R~\text{ideal}\\M\sse I}}I
    \]
    as the ideal \emph{generated by} $M$.
    \item Let $\left(I_{\lambda}\right)_{\lambda\in \Lambda}$ be a family of ideals. Then their \emph{sum} is defined as:
    \[
    \sum_{\lambda \in \Lambda} \defined
    \lset \sum_{\lambda\in \Lambda}a_{\lambda}x_{\lambda} \;\middle|\;
    \begin{tabular}{@{}l@{}}
      $x_{\lambda}\in I_{\lambda},~a_{\lambda}\in R$ ,\\
      $a_{\Lambda}\neq 0$ for only finitely many $\lambda \in \Lambda$
     \end{tabular}
     \rset
     \]
     is the smallest ideal that contains all of the $I_{\lambda}$.
     \item Let $I,J\sse R$ be two ideals. Then their product is defined as:
     \begin{align*}
      IJ &\defined \genby{\lset xy\ssp x\in I,~y\in J\rset}\\
        &=
        \lset \sum_{i}x_iy_i \;\middle|\;
        \begin{tabular}{@{}l@{}}
          $x_i\in I,~y_i\in J$ ,\\
          $x_i,y_i\neq 0$ for only finitely many $i$
         \end{tabular}
         \rset
  \end{align*}
  \item We say two ideals $I,J\sse R$ are \emph{coprime}\index{coprime} if $I+J = R$ holds. If $I$ and $J$ are coprime then $IJ = I\cap J$ holds: The inclusion $IJ \sse I\cap J$ always holds since $I$ and $J$ are ideals. For the other inclusion, we note that there are elements $x\in I$ and $y\in J$ such that $x+y = 1$ holds. Now for any $a\in I\cap J$ we have $a = ax+by$ and the second term is in $IJ$.
\end{enumerate}
\end{remdef}
\begin{mprop}
  Let $R$ be a ring and $I_1,\hdots,I_n\sse R$ ideals. Denote by $\phi$ the canonical map
  \begin{eqnarray*}
    \phi: R&\longrightarrow & \prod_{i=1}^n R/I_i\\
    x & \longmapsto & \left(\overline{x},\hdots,\overline{x}\right).
  \end{eqnarray*}
  \begin{enumerate}
    \item If $I_i+I_j = R$ for all $i\neq j$ then $\cap R/I_i \cong \prod R/I_i$.
    \item The map $\phi$ is surjective if and only if $I_i+I_j = R$ for all $i\neq j$.
    \item The kernel of $\phi$ is given by $\cap I_i$. In particular, $\phi$ is injective if and only if  $\cap I_i = \genby{0}$.
  \end{enumerate}
\end{mprop}
\begin{proof}
  \leavevmode
  \begin{enumerate}
  \item   We will do this by induction on $n$. The case $n=2$ is iv) in \cref{lec1:ideal-basic-ops}. In the general case, set
    \[
    K \defined \prod_{i=1}^{n-1} I_i = \bigcap_{i=1}^{n-1}I_i,
    \]
    where the last equality follows by induction.
    Now there are $a_i \in I_i$ and $b_i \in I_n$ for $1\leq i \leq n-1$ such that $a_i + b_i = 1$ and thus
    \[
    \prod_{i=1}^{n-1} a_i = \prod_{i=1}^{n-1}\left(1-b_i\right).
    \]
    Hence $K+I_n = R$ which implies
    \[
    \bigcap_{i=1}^n I_k= K\cap I_n = KI_n  = \prod_{i=1}^n I_n.
    \]
    \item It to show that $I_1$ and $I_2$ are coprime we first note that there is an $x\in R$ such that $\phi(x) = \left(1,0,\hdots,0\right)$ (since $\phi$ is surjective). Hence $x\in I_2$ and $1-x\in I_1$ which implies
    \[
    1 = (1-x)+x \in I_1+I_2.\]
    The general case follows after a relabeling.\par
    For the other direction, we first show that $\left(1,0,\hdots,0\right)\in \im \phi$. Since the $I_i$ are coprime, there are $x_i\in I_1$ and $y_i \in I_9i$ ($2\leq i\leq n)$ such that $x_i + y_i = 1$.
    Now  for $x\defined \prod_{i=2}^n\left(1-x_i\right) = \prod_{i=2}^ny_i$ we have $x\in I_i$ for all $i\geq 2$ and $x\equiv 1~\text{mod}I_1$, which shows that $\left(1,0,\hdots,0\right)$ is in the image of $\phi$. The general claim follows after a relabeling and with the linearity of $\pphi$.
    \item The element $\left(\overline{x},\hdots,\overline{x}\right)$ is zero if and onyl if $x\in I_i$ for all $1\leq i \leq n$.
  \end{enumerate}
\end{proof}
\section{The Spectrum of a Ring}
%\coms This was changed in lecture 2.\come
\begin{defn}
  Let $R$ be a ring, $M\sse R$ a set. We define
  \[
  Z(M)\defined
  \lset \idp \subset R \;\middle|\;
  \begin{tabular}{@{}l@{}}
    $\idp$ is a prime ideal of $R$,\\
    $M \sse \idp$.
   \end{tabular}
   \rset.
  \]
  In other places, the set $Z(M)$ is also denoted as $V(M)$.
\end{defn}
\begin{lem}
  For every set $M\sse R$
  \[
  Z\left(M\right) = Z\left(\genby{M}\right)
  \]
  holds.
\end{lem}
%\begin{mdefn}\label{1: zi altdef}
%  For later purposes, it will be useful to extend this defintion to general subsets $M\sse R$. For a general subset, we define
%  \[
%  Z(M)\defined
%  \lset \idp \subset R \;\middle|\;
%  \begin{tabular}{@{}l@{}}
%    $\idp$ is a prime ideal of $R$,\\
%    $M \sse \idp$.
%   \end{tabular}
%   \rset.
%  \]
%\end{mdefn}

\begin{example}\label{1: zi example}
  \leavevmode
  \begin{enumerate}
    \item $Z\left(\genby{1}\right) = \emptyset$. $Z\left(\genby{0}\right)$ is the set of all prime ideals.
    \item Let $\idm$ be a maximal ideal. Then $Z(\idm) = \{\idm\}$. For prime ideals, the converse is also true:
    Let $\idp$ be a prime ideal with $Z(\idp) = \lset \idp \rset$. By \cref{1: maximal existence}, there is a maximal ideal $\idm$ containing $\idp$. So $\lset \idp, \idm\rset \sse Z\left(\idp\right)$, which implies $\idp = \idm$. Hence $\idp$ is maximal.
    \item Consider $\zz$, and let $n\in \zz$. Then $Z\left(\genby{n}\right) = \lset p \ssp p\text{ prime}, p\text{ divides } n\rset$.
  \end{enumerate}
\end{example}

\begin{defn}
  Let $X$ be a set and $V$ a system of subsets of $X$. We say $V$ defines a \emph{topology} \index{topology} on $X$ if the following holds:
  \begin{enumerate}
    \item arbitrary intersections of elements of $V$ are again in $V$;
    \item finite unions of elements of $V$ are again in $V$;
    \item $X$ and $\emptyset$ are in $V$.\\
  \end{enumerate}
  In this case, the elements of $V$ are called \emph{closed sets}.
\end{defn}

\begin{prop}\label{1: zi basic props}
  Let $I,J\sse R$ be ideals and $\lset I_{\lambda}\rset_{\lambda \in \Lambda}$ a collection of ideals of $R$.
  \begin{enumerate}
    \item If $I\sse J$ then $Z(I)\supseteq Z(J)$;
    \item $Z(IJ) = Z(I) \cup Z(J)$;
    \item $Z\left(\sum_{\lambda \in \Lambda}I_{\lambda}\right) = \bigcap_{\lambda \in \Lambda} Z\left(I_{\lambda}\right)$.
  \end{enumerate}
\end{prop}
\begin{proof}
  \leavevmode
  \begin{enumerate}
    \item Every prime ideal that contains $J$ also contains $I$, hence $Z(J) \sse Z(I)$.
    \item $IJ$ is a subset of both $I$ and $J$. So by i), $Z(IJ) \supseteq Z(I)$ and $Z(IJ) \supseteq Z(J)$; hence $Z(IJ) \supseteq Z(I)\cup Z(J)$.\par
    Let $\idp$ be a prime ideal with $IJ \sse \idp$. Assume $I \nsubseteq \idp$, and let $x\in I$ be an element with $x\notin \idp$. For all $y\in J$ the product $xy$ is an element of $IJ \sse \idp$. As $\idp$ is a prime ideal, $y\in \idp$ follows, and hence $J \sse \idp$. This implies $Z(IJ) \subseteq Z(I) \cup Z(J)$.
    \item Let $\idp$ be a prime ideal that contains all of the $I_{\lambda}$. As ideals are closed under addition, $\idp$ also contains $\sum_{\lambda \in \Lambda}I_{\lambda}$ and hence \[\bigcap_{\lambda \in \Lambda}Z(I_{\lambda}) \sse Z\left(\sum_{\lambda \in \Lambda}I_{\lambda}\right)\]
    follows.
    On the other hand, every $I_{\lambda}$ is a subset of $\sum_{\lambda \in \Lambda}I_{\lambda}$, so every prime ideal that contains $\sum_{\lambda \in \Lambda}I_{\lambda}$ in particular contains each $I_{\lambda}$, and hence $Z\left(\sum_{\lambda \in \Lambda}I_{\lambda}\right) \sse \bigcap_{\lambda \in \Lambda}Z(I_{\lambda})$.
  \end{enumerate}
\end{proof}

\begin{cor}\label{1: zariski top}
  The collection of the $Z(I)$ for all ideals $I$ of $R$ define a topology on the set of all prime ideals of $R$.
\end{cor}
\begin{defn}
  The \emph{spectrum} $\spec R$ of $R$ is the set of all prime ideals of $R$ with the topology from \cref{1: zariski top}. This topology is called the \emph{Zariski topology}.\index{Zariski topology! on $\spec R$} \index{spectrum}
\end{defn}
\begin{mdefn}
  We denote by $\maxspec R$ the set of all maximal ideals of $R$.
\end{mdefn}
\begin{defn}
  A set in $\spec R$ is \emph{open} if it is of the form $\spec R \setminus Z(I)$, for an ideal $I$.
\end{defn}
Recall the following fact about quotient rings:
\begin{prop}
\label{1: quotient ring uniprop}
  Let $I\sse R$ be an ideal and $\pphi: R\to R'$ a ring homomorphism such that $I\sse \ker \pphi$. Then there is a unique ring homomorphism $\pphi':R/I\to R'$ such that the following diagram commutes:
  \[
  \begin{tikzcd}
    R\ar{r}[above]{\pphi} \ar{d}&
    R'\\
    R/I\ar[dashed]{ur}[below right]{\pphi'}&
  \end{tikzcd}
  \]
  In the case $I= \ker \pphi$, $\pphi'$ is a ring isomorphism
  \[
  \begin{tikzcd}
    R/\ker \pphi\ar{r}[above]{\sim}&
    \im \pphi.
  \end{tikzcd}
  \]
\end{prop}
\begin{lem}\label{1: preimages of prime are prime}
  Let $\pphi:R\to R'$ be a ring homomorphism and $\idp \subset R'$ a prime ideal. Then the preimage $\pphi^{-1}\left(\idp\right)\subset R$ is again a prime ideal.
\end{lem}
\begin{proof}
  Consider the composition
  \[
  \begin{tikzcd}[cramped]
    \tilde{\pphi}:R\ar{r}[above]{\pphi}&
    R'\ar{r}&
    R'/\idp
  \end{tikzcd}.
  \]
  Then $\ker \tilde{\pphi} = \pphi^{-1}\left(\idp\right)$. By \cref{1: quotient ring uniprop}, there exists a unique, injective ring homomorphism $\pphi': R/\pphi^{-1}\left(\idp\right)\to R'/\idp$ such that the diagram
  \[
  \begin{tikzcd}[cramped]
    R\ar{r}[above]{\pphi}\ar{d}&
    R'\ar{r}&
    R'/\idp\\
    R/\pphi^{-1}\left(\idp\right)\ar[dashed, bend left = -20]{urr}[below right]{\pphi'}&
    &
  \end{tikzcd}
  \]
  commutes.\par
  This identifies $R/\pphi^{-1}\left(\idp\right)$ with a subring of $R'/\idp$. By applying \cref{lec1:primmax-alt-char} twice, we get that $\pphi^{-1}\left(\idp\right)$ is indeed a prime ideal.
\end{proof}
\begin{mrem}
  This statement is in general not true for maximal ideals: Consider the embedding $\zz \hookrightarrow \rationals$. Then the preimage of the maximal ideal $\genby{0}\sse \rationals$  is $\genby{0}$, but $\genby{0}$ is not maximal in $\zz$.
\end{mrem}
\begin{prop}
  Every ring homomorphism $\pphi:R\to R'$ induces a continous map
  \begin{eqnarray*}
    \pphi^{\#}: \spec R'&\longrightarrow&\spec R\\
    \idp & \longmapsto & \pphi^{-1}\left(\idp\right).
  \end{eqnarray*}
\end{prop}
\begin{proof}
  By \cref{1: preimages of prime are prime}, $\pphi^{\#}$ is well-defined.\par
  Let $I \sse R$ be an ideal. Then
  \begin{align*}
    \left(\pphi^{\#}\right)^{-1}\left( Z(I)\right)  &= \lset \idp \in \spec R' \ssp \pphi^{\#}(\idp) \in Z(I)\rset \\
                                  &= \lset \idp \in \spec R' \ssp I \sse \pphi^{-1}(\idp)\rset \\
                                  &= \lset \idp \in \spec R' \ssp \pphi\left(I\right) \sse \idp \rset \\
                                  &= Z\left(\pphi(I)\right),
  \end{align*}
  so $\pphi^{\#}$ is continous, as preimages of closed sets are closed.
\end{proof}
\begin{mnotation}
  The map $\pphi^{\#}$ is also denoted as $\spec \pphi$.
\end{mnotation}
\begin{cor}
%\leavevmode
%\begin{enumerate}
%\item
  The assignment of the spectrum to a ring can be intepreted as a functor
  \[
  \spec: \cring^\op \longrightarrow \topspace.\]
  In particular: Isomorphic rings have homeomorphic spectra.
%  \item Isomorphic rings have homeomorphic spectra.
%\end{enumerate}
\end{cor}
\begin{rem}
  \leavevmode
  \begin{enumerate}
    \item Let $R$ be an integral domain. This is equivalent to $\genby{0}$ being a prime ideal. Now let $\idp$ be any prime ideal. Then $\genby{0}$ is in every open subset containing $\idp$. So $\spec R$ is not Hausdorff.
    \item For any prime ideal $\idp \in \spec R$,
    \[
    \overline{\lset\idp\rset} = \bigcap_{\substack{I\sse \idp \\ I\text{ ideal}}} Z(I) = Z(\idp).
    \]
    So $\idp$ is maximal if and only if $\lset \idp \rset$ is closed in $\spec R$ (by \cref{1: zi example}).
    \item Let $R$ be an integral domain. Then $\genby{0}\in \spec R$ is a point with
    \[
    \overline{\lset \genby{0}\rset} = Z\left(\genby{0}\right) = \spec R.
    \]
  \end{enumerate}
\end{rem}
\begin{mrem}\label{lec1:prime-ideals-in-quotient}
  Let $I\sse R$ be an ideal. Then the projection $\pi:R\surarr R/I$ induces a homeomorphism
  \begin{eqnarray*}
    \pi^{\#}: \spec R/I & \isomorphism & Z(I)\\
              \idp & \longmapsto & \pi^{-1}(\idp).
  \end{eqnarray*}
\end{mrem}
\begin{proof}
  We already know that $\pi^{\#}:\spec R/I\to \spec R$ has image $Z(I)$ and that is injective and continous. So we only need to show that $\pi$ is closed, but this imediate.
\end{proof}
\begin{lem}
  $\spec R$ is \emph{quasi-compact}: for every covering
  \[
  \spec R = \bigcup_{\lambda \in \Lambda}U_{\lambda}
  \]
  where each of the $U_{\lambda}$ is an open subset of $\spec R$ and $\Lambda$ an arbitrary index set, there are finitely many $U_{\lambda_1},\hdots,U_{\lambda_n}$ such that
  \[
  \spec R = \bigcup_{i=1}^n U_{\lambda_i}.
  \]
\end{lem}
\begin{proof}
  This will be on the first exercise sheet.
\end{proof}
\lec
